Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.geometry.euclidean.threed
Class Vector3D

    java.lang.Object
      org.apache.commons.math3.geometry.euclidean.threed.Vector3D

All Implemented Interfaces:
  Serializable, Vector<Euclidean3D>

    public class Vector3D

extends Object
implements Serializable, Vector<Euclidean3D>

This class implements vectors in a three-dimensional space.

Instance of this class are guaranteed to be immutable.

Since:
  1.2
Version:
  $Id: Vector3D.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Serialized Form

Field Summary
`static Vector3D` | `MINUS_I` Opposite of the first canonical vector (coordinates: -1, 0, 0).
`static Vector3D` | `MINUS_J` Opposite of the second canonical vector (coordinates: 0, -1, 0).
`static Vector3D` | `MINUS_K` Opposite of the third canonical vector (coordinates: 0, 0, -1).
`static Vector3D` | `NaN` A vector with all coordinates set to NaN.
`static Vector3D` | `NEGATIVE_INFINITY` A vector with all coordinates set to negative infinity.
`static Vector3D` | `PLUS_I` First canonical vector (coordinates: 1, 0, 0).
`static Vector3D` | `PLUS_J` Second canonical vector (coordinates: 0, 1, 0).
`static Vector3D` | `PLUS_K` Third canonical vector (coordinates: 0, 0, 1).
`static Vector3D` | `POSITIVE_INFINITY` A vector with all coordinates set to positive infinity.
`static Vector3D` | `ZERO` Null vector (coordinates: 0, 0, 0).

Constructor Summary
`Vector3D(double[] v)` Simple constructor.
`Vector3D(double alpha, double delta)` Simple constructor.
`Vector3D(double x, double y, double z)` Simple constructor.
`Vector3D(double a, Vector3D u)` Multiplicative constructor Build a vector from another one and a scale factor.
`Vector3D(double a1, Vector3D u1, double a2, Vector3D u2)` Linear constructor Build a vector from two other ones and corresponding scale factors.
`Vector3D(double a1, Vector3D u1, double a2, Vector3D u2, double a3, Vector3D u3)` Linear constructor Build a vector from three other ones and corresponding scale factors.
`Vector3D(double a1, Vector3D u1, double a2, Vector3D u2, double a3, Vector3D u3, double a4, Vector3D u4)` Linear constructor Build a vector from four other ones and corresponding scale factors.

Method Summary
`Vector3D` | `add(double factor, Vector<Euclidean3D> v)` Add a scaled vector to the instance.
`Vector3D` | `add(Vector<Euclidean3D> v)` Add a vector to the instance.
`static double` | `angle(Vector3D v1, Vector3D v2)` Compute the angular separation between two vectors.
`Vector3D` | `crossProduct(Vector<Euclidean3D> v)` Compute the cross-product of the instance with another vector.
`static Vector3D` | `crossProduct(Vector3D v1, Vector3D v2)` Compute the cross-product of two vectors.
`double` | `distance(Vector<Euclidean3D> v)` Compute the distance between the instance and another vector according to the L2 norm.
`static double` | `distance(Vector3D v1, Vector3D v2)` Compute the distance between two vectors according to the L2 norm.
`double` | `distance1(Vector<Euclidean3D> v)` Compute the distance between the instance and another vector according to the L1 norm.
`static double` | `distance1(Vector3D v1, Vector3D v2)` Compute the distance between two vectors according to the L1 norm.
`double` | `distanceInf(Vector<Euclidean3D> v)` Compute the distance between the instance and another vector according to the L∞ norm.
`static double` | `distanceInf(Vector3D v1, Vector3D v2)` Compute the distance between two vectors according to the L∞ norm.
`double` | `distanceSq(Vector<Euclidean3D> v)` Compute the square of the distance between the instance and another vector.
`static double` | `distanceSq(Vector3D v1, Vector3D v2)` Compute the square of the distance between two vectors.
`double` | `dotProduct(Vector<Euclidean3D> v)` Compute the dot-product of the instance and another vector.
`static double` | `dotProduct(Vector3D v1, Vector3D v2)` Compute the dot-product of two vectors.
`boolean` | `equals(Object other)` Test for the equality of two 3D vectors.
`double` | `getAlpha()` Get the azimuth of the vector.
`double` | `getDelta()` Get the elevation of the vector.
`double` | `getNorm()` Get the L2 norm for the vector.
`double` | `getNorm1()` Get the L1 norm for the vector.
`double` | `getNormInf()` Get the L∞ norm for the vector.
`double` | `getNormSq()` Get the square of the norm for the vector.
`Space` | `getSpace()` Get the space to which the vector belongs.
`double` | `getX()` Get the abscissa of the vector.
`double` | `getY()` Get the ordinate of the vector.
`double` | `getZ()` Get the height of the vector.
`Vector3D` | `getZero()` Get the null vector of the vectorial space or origin point of the affine space.
`int` | `hashCode()` Get a hashCode for the 3D vector.
`boolean` | `isInfinite()` Returns true if any coordinate of this vector is infinite and none are NaN; false otherwise
`boolean` | `isNaN()` Returns true if any coordinate of this vector is NaN; false otherwise
`Vector3D` | `negate()` Get the opposite of the instance.
`Vector3D` | `normalize()` Get a normalized vector aligned with the instance.
`Vector3D` | `orthogonal()` Get a vector orthogonal to the instance.
`Vector3D` | `scalarMultiply(double a)` Multiply the instance by a scalar.
`Vector3D` | `subtract(double factor, Vector<Euclidean3D> v)` Subtract a scaled vector from the instance.
`Vector3D` | `subtract(Vector<Euclidean3D> v)` Subtract a vector from the instance.
`double[]` | `toArray()` Get the vector coordinates as a dimension 3 array.
`String` | `toString()` Get a string representation of this vector.
`String` | `toString(NumberFormat format)` Get a string representation of this vector.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO

    public static final Vector3D ZERO

  Null vector (coordinates: 0, 0, 0).

### PLUS_I

    public static final Vector3D PLUS_I

  First canonical vector (coordinates: 1, 0, 0).

### MINUS_I

    public static final Vector3D MINUS_I

  Opposite of the first canonical vector (coordinates: -1, 0, 0).

### PLUS_J

    public static final Vector3D PLUS_J

  Second canonical vector (coordinates: 0, 1, 0).

### MINUS_J

    public static final Vector3D MINUS_J

  Opposite of the second canonical vector (coordinates: 0, -1, 0).

### PLUS_K

    public static final Vector3D PLUS_K

  Third canonical vector (coordinates: 0, 0, 1).

### MINUS_K

    public static final Vector3D MINUS_K

  Opposite of the third canonical vector (coordinates: 0, 0, -1).

### NaN

    public static final Vector3D NaN

  A vector with all coordinates set to NaN.

### POSITIVE_INFINITY

    public static final Vector3D POSITIVE_INFINITY

  A vector with all coordinates set to positive infinity.

### NEGATIVE_INFINITY

    public static final Vector3D NEGATIVE_INFINITY

  A vector with all coordinates set to negative infinity.

Constructor Detail

### Vector3D

    public Vector3D(double x,
                    double y,
                    double z)

  Simple constructor. Build a vector from its coordinates

  Parameters:
    `x` - abscissa
    `y` - ordinate
    `z` - height
  See Also:
    `getX()`, `getY()`, `getZ()`

### Vector3D

    public Vector3D(double[] v)
             throws DimensionMismatchException

  Simple constructor. Build a vector from its coordinates

  Parameters:
    `v` - coordinates array
  Throws:
    `DimensionMismatchException` - if array does not have 3 elements
  See Also:
    `toArray()`

### Vector3D

    public Vector3D(double alpha,
                    double delta)

  Simple constructor. Build a vector from its azimuthal coordinates

  Parameters:
    `alpha` - azimuth (α) around Z (0 is +X, π/2 is +Y, π is -X and 3π/2 is -Y)
    `delta` - elevation (δ) above (XY) plane, from -π/2 to +π/2
  See Also:
    `getAlpha()`, `getDelta()`

### Vector3D

    public Vector3D(double a,
                    Vector3D u)

  Multiplicative constructor Build a vector from another one and a scale factor. The vector built will be a * u

  Parameters:
    `a` - scale factor
    `u` - base (unscaled) vector

### Vector3D

    public Vector3D(double a1,
                    Vector3D u1,
                    double a2,
                    Vector3D u2)

  Linear constructor Build a vector from two other ones and corresponding scale factors. The vector built will be a1 * u1 + a2 * u2

  Parameters:
    `a1` - first scale factor
    `u1` - first base (unscaled) vector
    `a2` - second scale factor
    `u2` - second base (unscaled) vector

### Vector3D

    public Vector3D(double a1,
                    Vector3D u1,
                    double a2,
                    Vector3D u2,
                    double a3,
                    Vector3D u3)

  Linear constructor Build a vector from three other ones and corresponding scale factors. The vector built will be a1 * u1 + a2 * u2 + a3 * u3

  Parameters:
    `a1` - first scale factor
    `u1` - first base (unscaled) vector
    `a2` - second scale factor
    `u2` - second base (unscaled) vector
    `a3` - third scale factor
    `u3` - third base (unscaled) vector

### Vector3D

    public Vector3D(double a1,
                    Vector3D u1,
                    double a2,
                    Vector3D u2,
                    double a3,
                    Vector3D u3,
                    double a4,
                    Vector3D u4)

  Linear constructor Build a vector from four other ones and corresponding scale factors. The vector built will be a1 * u1 + a2 * u2 + a3 * u3 + a4 * u4

  Parameters:
    `a1` - first scale factor
    `u1` - first base (unscaled) vector
    `a2` - second scale factor
    `u2` - second base (unscaled) vector
    `a3` - third scale factor
    `u3` - third base (unscaled) vector
    `a4` - fourth scale factor
    `u4` - fourth base (unscaled) vector

Method Detail

### getX

    public double getX()

  Get the abscissa of the vector.

  Returns:
    abscissa of the vector
  See Also:
    `Vector3D(double, double, double)`

### getY

    public double getY()

  Get the ordinate of the vector.

  Returns:
    ordinate of the vector
  See Also:
    `Vector3D(double, double, double)`

### getZ

    public double getZ()

  Get the height of the vector.

  Returns:
    height of the vector
  See Also:
    `Vector3D(double, double, double)`

### toArray

    public double[] toArray()

  Get the vector coordinates as a dimension 3 array.

  Returns:
    vector coordinates
  See Also:
    `Vector3D(double[])`

### getSpace

    public Space getSpace()

  Get the space to which the vector belongs.

  Specified by:
    `getSpace` in interface `Vector<Euclidean3D>`
  Returns:
    containing space

### getZero

    public Vector3D getZero()

  Get the null vector of the vectorial space or origin point of the affine space.

  Specified by:
    `getZero` in interface `Vector<Euclidean3D>`
  Returns:
    null vector of the vectorial space or origin point of the affine space

### getNorm1

    public double getNorm1()

  Get the L1 norm for the vector.

  Specified by:
    `getNorm1` in interface `Vector<Euclidean3D>`
  Returns:
    L1 norm for the vector

### getNorm

    public double getNorm()

  Get the L2 norm for the vector.

  Specified by:
    `getNorm` in interface `Vector<Euclidean3D>`
  Returns:
    Euclidean norm for the vector

### getNormSq

    public double getNormSq()

  Get the square of the norm for the vector.

  Specified by:
    `getNormSq` in interface `Vector<Euclidean3D>`
  Returns:
    square of the Euclidean norm for the vector

### getNormInf

    public double getNormInf()

  Get the L∞ norm for the vector.

  Specified by:
    `getNormInf` in interface `Vector<Euclidean3D>`
  Returns:
    L∞ norm for the vector

### getAlpha

    public double getAlpha()

  Get the azimuth of the vector.

  Returns:
    azimuth (α) of the vector, between -π and +π
  See Also:
    `Vector3D(double, double)`

### getDelta

    public double getDelta()

  Get the elevation of the vector.

  Returns:
    elevation (δ) of the vector, between -π/2 and +π/2
  See Also:
    `Vector3D(double, double)`

### add

    public Vector3D add(Vector<Euclidean3D> v)

  Add a vector to the instance.

  Specified by:
    `add` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - vector to add
  Returns:
    a new vector

### add

    public Vector3D add(double factor,
                        Vector<Euclidean3D> v)

  Add a scaled vector to the instance.

  Specified by:
    `add` in interface `Vector<Euclidean3D>`
  Parameters:
    `factor` - scale factor to apply to v before adding it
    `v` - vector to add
  Returns:
    a new vector

### subtract

    public Vector3D subtract(Vector<Euclidean3D> v)

  Subtract a vector from the instance.

  Specified by:
    `subtract` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - vector to subtract
  Returns:
    a new vector

### subtract

    public Vector3D subtract(double factor,
                             Vector<Euclidean3D> v)

  Subtract a scaled vector from the instance.

  Specified by:
    `subtract` in interface `Vector<Euclidean3D>`
  Parameters:
    `factor` - scale factor to apply to v before subtracting it
    `v` - vector to subtract
  Returns:
    a new vector

### normalize

    public Vector3D normalize()
                       throws MathArithmeticException

  Get a normalized vector aligned with the instance.

  Specified by:
    `normalize` in interface `Vector<Euclidean3D>`
  Returns:
    a new normalized vector
  Throws:
    `MathArithmeticException` - if the norm is zero

### orthogonal

    public Vector3D orthogonal()
                        throws MathArithmeticException

  Get a vector orthogonal to the instance.

  There are an infinite number of normalized vectors orthogonal to the instance. This method picks up one of them almost arbitrarily. It is useful when one needs to compute a reference frame with one of the axes in a predefined direction. The following example shows how to build a frame having the k axis aligned with the known vector u :

         Vector3D k = u.normalize();
         Vector3D i = k.orthogonal();
         Vector3D j = Vector3D.crossProduct(k, i);

  Returns:
    a new normalized vector orthogonal to the instance
  Throws:
    `MathArithmeticException` - if the norm of the instance is null

### angle

    public static double angle(Vector3D v1,
                               Vector3D v2)
                        throws MathArithmeticException

  Compute the angular separation between two vectors.

  This method computes the angular separation between two vectors using the dot product for well separated vectors and the cross product for almost aligned vectors. This allows to have a good accuracy in all cases, even for vectors very close to each other.

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    angular separation between v1 and v2
  Throws:
    `MathArithmeticException` - if either vector has a null norm

### negate

    public Vector3D negate()

  Get the opposite of the instance.

  Specified by:
    `negate` in interface `Vector<Euclidean3D>`
  Returns:
    a new vector which is opposite to the instance

### scalarMultiply

    public Vector3D scalarMultiply(double a)

  Multiply the instance by a scalar.

  Specified by:
    `scalarMultiply` in interface `Vector<Euclidean3D>`
  Parameters:
    `a` - scalar
  Returns:
    a new vector

### isNaN

    public boolean isNaN()

  Returns true if any coordinate of this vector is NaN; false otherwise

  Specified by:
    `isNaN` in interface `Vector<Euclidean3D>`
  Returns:
    true if any coordinate of this vector is NaN; false otherwise

### isInfinite

    public boolean isInfinite()

  Returns true if any coordinate of this vector is infinite and none are NaN; false otherwise

  Specified by:
    `isInfinite` in interface `Vector<Euclidean3D>`
  Returns:
    true if any coordinate of this vector is infinite and none are NaN; false otherwise

### equals

    public boolean equals(Object other)

  Test for the equality of two 3D vectors.

  If all coordinates of two 3D vectors are exactly the same, and none are `Double.NaN`, the two 3D vectors are considered to be equal.

  `NaN` coordinates are considered to affect globally the vector and be equals to each other - i.e, if either (or all) coordinates of the 3D vector are equal to `Double.NaN`, the 3D vector is equal to `NaN`.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - Object to test for equality to this
  Returns:
    true if two 3D vector objects are equal, false if object is null, not an instance of Vector3D, or not equal to this Vector3D instance

### hashCode

    public int hashCode()

  Get a hashCode for the 3D vector.

  All NaN values have the same hash code.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object

### dotProduct

    public double dotProduct(Vector<Euclidean3D> v)

  Compute the dot-product of the instance and another vector.

  The implementation uses specific multiplication and addition algorithms to preserve accuracy and reduce cancellation effects. It should be very accurate even for nearly orthogonal vectors.

  Specified by:
    `dotProduct` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - second vector
  Returns:
    the dot product this.v
  See Also:
    `MathArrays.linearCombination(double, double, double, double, double, double)`

### crossProduct

    public Vector3D crossProduct(Vector<Euclidean3D> v)

  Compute the cross-product of the instance with another vector.

  Parameters:
    `v` - other vector
  Returns:
    the cross product this ^ v as a new Vector3D

### distance1

    public double distance1(Vector<Euclidean3D> v)

  Compute the distance between the instance and another vector according to the L1 norm.

  Calling this method is equivalent to calling: `q.subtract(p).getNorm1()` except that no intermediate vector is built

  Specified by:
    `distance1` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - second vector
  Returns:
    the distance between the instance and p according to the L1 norm

### distance

    public double distance(Vector<Euclidean3D> v)

  Compute the distance between the instance and another vector according to the L2 norm.

  Calling this method is equivalent to calling: `q.subtract(p).getNorm()` except that no intermediate vector is built

  Specified by:
    `distance` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - second vector
  Returns:
    the distance between the instance and p according to the L2 norm

### distanceInf

    public double distanceInf(Vector<Euclidean3D> v)

  Compute the distance between the instance and another vector according to the L∞ norm.

  Calling this method is equivalent to calling: `q.subtract(p).getNormInf()` except that no intermediate vector is built

  Specified by:
    `distanceInf` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - second vector
  Returns:
    the distance between the instance and p according to the L∞ norm

### distanceSq

    public double distanceSq(Vector<Euclidean3D> v)

  Compute the square of the distance between the instance and another vector.

  Calling this method is equivalent to calling: `q.subtract(p).getNormSq()` except that no intermediate vector is built

  Specified by:
    `distanceSq` in interface `Vector<Euclidean3D>`
  Parameters:
    `v` - second vector
  Returns:
    the square of the distance between the instance and p

### dotProduct

    public static double dotProduct(Vector3D v1,
                                    Vector3D v2)

  Compute the dot-product of two vectors.

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the dot product v1.v2

### crossProduct

    public static Vector3D crossProduct(Vector3D v1,
                                        Vector3D v2)

  Compute the cross-product of two vectors.

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the cross product v1 ^ v2 as a new Vector

### distance1

    public static double distance1(Vector3D v1,
                                   Vector3D v2)

  Compute the distance between two vectors according to the L1 norm.

  Calling this method is equivalent to calling: `v1.subtract(v2).getNorm1()` except that no intermediate vector is built

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the distance between v1 and v2 according to the L1 norm

### distance

    public static double distance(Vector3D v1,
                                  Vector3D v2)

  Compute the distance between two vectors according to the L2 norm.

  Calling this method is equivalent to calling: `v1.subtract(v2).getNorm()` except that no intermediate vector is built

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the distance between v1 and v2 according to the L2 norm

### distanceInf

    public static double distanceInf(Vector3D v1,
                                     Vector3D v2)

  Compute the distance between two vectors according to the L∞ norm.

  Calling this method is equivalent to calling: `v1.subtract(v2).getNormInf()` except that no intermediate vector is built

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the distance between v1 and v2 according to the L∞ norm

### distanceSq

    public static double distanceSq(Vector3D v1,
                                    Vector3D v2)

  Compute the square of the distance between two vectors.

  Calling this method is equivalent to calling: `v1.subtract(v2).getNormSq()` except that no intermediate vector is built

  Parameters:
    `v1` - first vector
    `v2` - second vector
  Returns:
    the square of the distance between v1 and v2

### toString

    public String toString()

  Get a string representation of this vector.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this vector

### toString

    public String toString(NumberFormat format)

  Get a string representation of this vector.

  Specified by:
    `toString` in interface `Vector<Euclidean3D>`
  Parameters:
    `format` - the custom format for components
  Returns:
    a string representation of this vector

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.